--[[
    Author: KepocuH

    This is a space scanning plugin, which looks asynchronously for an objects, those names may
    include elements of search_list as their parts. The scan continues until the object is found
    or scan turned off manually. You may add the search patterns to the search_list by /scan_add
    command and remove them  by /scan_del. You may toggle the scan by issuing the /scan_toggle
    command.

    scan_add and scan_del are accepting multipli arguments at once

    /scan_add arthemis nanite
    /scan_del orun scrap

    It is practical that you bind the toggle to some button like:
    -----
    /bind F2 scan_toggle
    -----


    The origin of sound10.ogg is a  SoundAlertSuite plugin. 

--]]

spaceScan = {}

local search_list= {
    "xit",
    "hive",
    "cpu",
    "proc",
    "synth",
    "grade",
    "neural",
    "cyber"
}

local __CMD="RadarNext";

local __timeout=50;
local __rescan=5000;
local __dosearch=false;
local __SearchTimer=Timer();
local __RescanTimer=Timer();
local __SL_Iterator=1;
local __SoundName="sound10.ogg";
local __MasterVolume=tonumber(gkini.ReadString("SAS", "master_volume", '1.0'));

local __search_sound = gksound.GKLoadSound{soundname=__SoundName,filename="plugins/spaceScan/sounds/"..__SoundName};

function lookup()
   local name="XUBADOOO"

   __SearchTimer:Kill();

   gkinterface.GKProcessCommand(__CMD);
   name = GetTargetInfo()
   if((name ~=nil) and (name ~= "XUBADOOO"))
   then
        local tmpstr = name:lower()

        if(__SL_Iterator == table.maxn(search_list))
        then
            __SL_Iterator=1;
        end


        if(tmpstr:find(search_list[__SL_Iterator]:lower()))
        then
            generalprint("Found: "..tmpstr)
            __dosearch=false;
        else
            __SearchTimer:SetTimeout(__timeout,reset_timer);
        end
        __SL_Iterator=__SL_Iterator + 1;
   else
        if(__CMD == "RadarNext")
        then
            __CMD="RadarPrev";
        else
            __CMD="RadarNext";
        end
        __SearchTimer:SetTimeout(__timeout,reset_timer);
   end
end

function reset_timer()
    __SearchTimer:Kill();
    if(__dosearch)
    then
        lookup();
        __SearchTimer:SetTimeout(__timeout,reset_timer);
    end
end

function search_heart_bit()
    if(__dosearch)
    then
        gksound.GKPlaySound(__SoundName, __MasterVolume);
        radar.SetRadarSelection(0,0)
        __RescanTimer:SetTimeout(__rescan, search_heart_bit);
    else
        __RescanTimer:Kill()
    end
end

function spaceScan:toggle(...)
    gksound.GKPlaySound(__SoundName, __MasterVolume);
    radar.SetRadarSelection(0,0)

    if(__dosearch)
    then
        __dosearch=false;
    else
        __dosearch=true;
    end

    search_heart_bit()
    reset_timer();
end

function spaceScan:add(data)
    if(data ~= nil)
    then
        for i=1,table.maxn(data)
        do
            table.insert(search_list,data[i]:lower());
        end
    end
end

function spaceScan:del(data)
    if(data ~= nil)
    then
        for j=1,table.maxn(data)
        do
            for i=1,table.maxn(search_list)
            do
                if(search_list[i]==data[j]:lower())
                then
                    table.remove(search_list,i);
                    break
                end
            end
        end
    end
end

function spaceScan:list()
    generalprint("spaceScan search list includes:");
    for i=1,table.maxn(search_list)
    do
        generalprint(search_list[i]);
    end
end

RegisterUserCommand("scan_toggle",spaceScan.toggle)
RegisterUserCommand("scan_add",spaceScan.add)
RegisterUserCommand("scan_del",spaceScan.del)
RegisterUserCommand("scan_list",spaceScan.list)
